;define error handling function to deal with cancelled commands
(defun *error* (msg / )
  (princ "error: ")
  (princ msg)
  (terpri)
  (shutdown)
)
;main program starts here
(defun appint (/ entity1 entity2)

  ;while selecting the first line repeat this section until something
  ;is actually picked and it is a line.  This could be extended to
  ;include 3DLINES if desired.

  (while (= entity1 nil)
    ;get the user to pick something
    (setq entity1 (entsel "\nSelect Line1: "))
    ;if they miss the entity when picking then loop round again
    (if (/= entity1 nil)
      ;check to see if what was picked is a line
      (if (/= (cdr (assoc 0 (entget (car entity1)))) "LINE")
        ;if it wasn't a line then reset, print a message and repeat
        (progn (setq entity1 nil)
          (princ "\not a LINE! ")
        )
      )
    )
  )
  ;do all the same checks for the second line

  (while (= entity2 nil)
    (setq entity2 (entsel "\nSelect Line2: "))
    (if (/= entity2 nil)
      (if (/= (cdr (assoc 0 (entget (car entity2)))) "LINE")
        (progn (setq entity2 nil)
          (princ "\nNot a LINE! ")
        )
      )
    )
  )

  ;set INT to the intersection point.  If there is no intersection
  ;then INT will equal nil.  If there is no intersection then print
  ;a message and exit cleanly back to the previous command.  If there
  ;is then return the point to the command line.

  (if (/= (setq int (inters 
		      (cdr (assoc 10 (entget (car entity1))))
		      (cdr (assoc 11 (entget (car entity1))))
		      (cdr (assoc 10 (entget (car entity2))))
		      (cdr (assoc 11 (entget (car entity2)))) nil)) nil)
      (command int)
      (progn
	(princ " No apparent intersection for specified lines.\ninvalid 
point.\n")
	;(princ)
      )
  )
(princ)
)
